library IEEE                    ;
use IEEE.STD_LOGIC_1164.ALL     ; 
use IEEE.STD_LOGIC_ARITH.ALL    ;
use IEEE.STD_LOGIC_UNSIGNED.ALL ;
use IEEE.MATH_REAL.ALL; -- Pour la fonction ceil notamment. 


entity barrel_shifter_16bits is
	port(
		i_A 	  : in  std_logic_vector(15 downto 0) ;
		i_shf     : in  std_logic_vector(3 downto 0) ; 
		q_shf     : out std_logic_vector(15 downto 0) 
	) ;
end entity barrel_shifter_16bits ; 

architecture behave of barrel_shifter_16bits is 

	type shf_array is array(3 downto 0) of std_logic_vector(15 downto 0) ; 
	
	signal tmp_shf : shf_array := (others=>(others=>'0')) ;

begin

	with i_shf(0) select -- shf = 1
		tmp_shf(0) <= i_A(14 downto 0) & i_A(15) when '1', 
					  i_A when others ;
	with i_shf(1) select -- shf = 2
		tmp_shf(1) <= tmp_shf(0)(13 downto 0) & tmp_shf(0)(15 downto 14) when '1', 
					  tmp_shf(0) when others ;					  
	with i_shf(2) select -- shf = 4
		tmp_shf(2) <= tmp_shf(1)(11 downto 0) & tmp_shf(1)(15 downto 12) when '1', 
					  tmp_shf(1) when others ;					  
	with i_shf(3) select -- shf = 8 
		tmp_shf(3) <= tmp_shf(2)(7 downto 0) & tmp_shf(2)(15 downto 8) when '1', 
					  tmp_shf(2) when others ;	
					  
	q_shf <= tmp_shf(3) ; 


end architecture behave ; 