library IEEE                    ;
use IEEE.STD_LOGIC_1164.ALL     ; 
use IEEE.STD_LOGIC_ARITH.ALL    ;
use IEEE.STD_LOGIC_UNSIGNED.ALL ;
use IEEE.MATH_REAL.ALL; -- Pour la fonction ceil notamment. 


entity adder is
	port(
		i_A : in std_logic_vector(15 downto 0) ; 
		i_B : in std_logic_vector(15 downto 0) ; 
		i_carry : in std_logic ; 
		q_add    : out std_logic_vector(15 downto 0) ;
		overflow : out std_logic 
	) ; 
end entity adder ; 


architecture behave of adder is

	component full_adder is
		port(
			i_A : in std_logic ; 
			i_B : in std_logic ; 
			i_carry : in std_logic ;
			q_add   : out std_logic ;
			q_carry : out std_logic 
		) ; 
	end component full_adder ; 

	signal carry_vector : std_logic_vector(16 downto 0) := (others=>'0');
	
begin 

	carry_vector(0) <= i_carry ;

	gen_adder : for I in 0 to 15 generate
		full_adder_i : full_adder
					   port map(
						i_A => i_A(I),
						i_B => i_B(I),
						i_carry => carry_vector(I),
						q_add => q_add(I),
						q_carry => carry_vector(I+1) 
						) ; 											 
	end generate gen_adder ;

	overflow <= carry_vector(16) ; 

end architecture behave ; 
