library IEEE                    ;
use IEEE.STD_LOGIC_1164.ALL     ; 
use IEEE.STD_LOGIC_ARITH.ALL    ;
use IEEE.STD_LOGIC_UNSIGNED.ALL ;
use IEEE.MATH_REAL.ALL; -- Pour la fonction ceil notamment. 

entity bench_barrel_shifter_16bits is
end entity bench_barrel_shifter_16bits ; 

architecture behave of bench_barrel_shifter_16bits is

	component barrel_shifter_16bits is
		port(
			i_A 	  : in  std_logic_vector(15 downto 0) ;
			i_shf     : in  std_logic_vector(3 downto 0) ; 
			q_shf     : out std_logic_vector(15 downto 0) 
		) ;
	end component barrel_shifter_16bits ; 
	
	signal l_i_A   : std_logic_vector(15 downto 0) := "0000000000000001" ; 
	signal l_i_shf : std_logic_vector(3 downto 0) := "0000" ; 
	signal l_q_shf : std_logic_vector(15 downto 0) := (others => '0') ; 
	
	signal cpt : std_logic_vector(3 downto 0) := (others => '0') ; 

begin

	barrel_shifter_16bits_inst_0 :  barrel_shifter_16bits
									port map(
										i_A   => l_i_A,
										i_shf => l_i_shf,
										q_shf => l_q_shf 
									) ; 
									
									
	process
	begin
		l_i_shf <= cpt ; 
		cpt <= cpt+1 ; 
		wait for 100 ns ; 		
	end process ; 


end architecture behave ; 