library IEEE                    ;
use IEEE.STD_LOGIC_1164.ALL     ; 
use IEEE.STD_LOGIC_ARITH.ALL    ;
use IEEE.STD_LOGIC_UNSIGNED.ALL ;
use IEEE.MATH_REAL.ALL; -- Pour la fonction ceil notamment. 


entity bench_adder is
end entity ; 

architecture behave of bench_adder is

	component adder is
		port(
			i_A : in std_logic_vector(15 downto 0) ; 
			i_B : in std_logic_vector(15 downto 0) ; 
			i_carry : in std_logic ; 
			q_add    : out std_logic_vector(15 downto 0) ;
			overflow : out std_logic 
		) ; 
	end component adder ; 
	
	signal l_i_A : std_logic_vector(15 downto 0) := (others=>'0'); 
	signal l_i_B : std_logic_vector(15 downto 0) := (others=>'0') ; 	
	signal l_q_add : std_logic_vector(15 downto 0) := (others=>'0') ; 	

begin

	adder_inst_0 : adder
				   port map(
					i_A => l_i_A,
					i_B => l_i_B,
					i_carry => '0',
					q_add => l_q_add
				) ; 

	process
	begin
		for i in 0 to 15 loop
			for j in 0 to 15 loop		
				wait for 100 ns ; 
				l_i_B <= l_i_B+1 ; 
			end loop ; 
			l_i_A <= l_i_A+1 ; 			
		end loop ; 
	
	end process ;



end architecture behave ; 