library IEEE                    ;
use IEEE.STD_LOGIC_1164.ALL     ; 
use IEEE.STD_LOGIC_ARITH.ALL    ;
use IEEE.STD_LOGIC_UNSIGNED.ALL ;
use IEEE.MATH_REAL.ALL; -- Pour la fonction ceil notamment. 


entity bench_ALU is
end entity bench_ALU ;

architecture behave of bench_ALU is

	component ALU is
		port(
			clk    : std_logic ; 
			i_OP   : in std_logic_vector(2 downto 0)  ; 
			i_LOAD : in std_logic					  ; 
			i_A    : in std_logic_vector(15 downto 0) ; 
			i_B    : in std_logic_vector(15 downto 0) ; 
			i_sub  : in std_logic ; -- bit de contrôle qui permet de différencier une addition d'une soustraction. 
			q_R  : out std_logic_vector(15 downto 0)  ; 
			rdy  : out std_logic 
		) ; 
	end component ALU ; 
	
	component Clock is
		port(
		clk : out std_logic 
	  );
	end component Clock ; 	
	
	signal clk    : std_logic ; 
	signal l_OP   : std_logic_vector(2 downto 0) ; 
	signal l_LOAD : std_logic ; 
	signal l_A    : std_logic_vector(15 downto 0) ; 
	signal l_B    : std_logic_vector(15 downto 0) ; 
	signal l_sub  : std_logic ; 
	signal l_R    : std_logic_vector(15 downto 0) ; 
	signal rdy    : std_logic ;  

begin

	clock_inst_0 : Clock
				   port map(clk=>clk) ; 

	ALU_inst_0 : ALU
				 port map(
					clk    => clk,
					i_OP   => l_OP,
					i_LOAD => l_LOAD,
					i_A    => l_A,
					i_B    => l_B,
					i_sub  => l_sub,
					q_R    => l_R,
					rdy    => rdy
				) ; 
				
	process
	begin
	
		l_A   <= "0000000001000011" ;
		l_B   <= "0000000000100001" ;
		l_OP  <= "000" ; 
		l_sub <= '0' ; 
		wait for 20 ns ; -- Addition
		l_OP  <= "000" ; 
		l_sub <= '1' ; 
		wait for 20 ns ; -- Soustraction
		l_LOAD <= '1' ;
		l_OP <= "001" ; -- Multiplication
		wait for 20 ns ;
		l_LOAD <= '0' ; 
		wait for 400 ns ;
		l_LOAD <= '1' ;
		l_OP <= "010" ; -- Division
		wait for 20 ns ; 
		l_LOAD <= '0' ; 
		wait for 400 ns ; 
		l_OP <= "110" ; -- Bitwise AND
		wait for 20 ns ;
	end process ; 
					


end architecture behave ; 