library IEEE                    ;
use IEEE.STD_LOGIC_1164.ALL     ; 
use IEEE.STD_LOGIC_ARITH.ALL    ;
use IEEE.STD_LOGIC_UNSIGNED.ALL ;
use IEEE.MATH_REAL.ALL; -- Pour la fonction ceil notamment. 


entity bench_divisor is
end entity ; 

architecture behave of bench_divisor is

	component divisor is
		port(
			clk : in std_logic ; 
			i_LOAD : in std_logic ; 		
			i_A : in std_logic_vector(15 downto 0) ;
			i_B : in std_logic_vector(15 downto 0) ;
			q_mult : out std_logic_vector(15 downto 0) ;
			rdy : out std_logic ;
			overflow : out std_logic 
		) ; 
	end component divisor ;
	
	component Clock is
		port(
		clk : out std_logic 
	  );
	end component Clock ; 	
	
	signal clk : std_logic ; 
	
	signal l_i_LOAD : std_logic := '1' ; 
	signal l_i_A : std_logic_vector(15 downto 0) := "0011100000001010"; 
	signal l_i_B : std_logic_vector(15 downto 0) := "0000000000010011" ; 	
	signal l_q_mult : std_logic_vector(15 downto 0) := (others=>'0') ; 	
	signal l_q_rdy : std_logic ; 
	signal l_overflow : std_logic ; 

begin

	clk_inst_0 : Clock
				 port map(
					clk => clk
				) ; 


	divisor_inst_0 : divisor
				   port map(
				    clk => clk,
					i_LOAD => l_i_LOAD,
					i_A => l_i_A,
					i_B => l_i_B,
					q_mult => l_q_mult,
					rdy  => l_q_rdy,
					overflow => l_overflow
				) ; 

	process
	begin
		l_i_LOAD <= '1' ;
		wait for 20 ns ; 
		l_i_LOAD <= '0' ; 
		wait for 5000 ns ; 		
	end process ; 




end architecture behave ; 