library IEEE                    ;
use IEEE.STD_LOGIC_1164.ALL     ; 
use IEEE.STD_LOGIC_ARITH.ALL    ;
use IEEE.STD_LOGIC_UNSIGNED.ALL ;


entity pc_bench is
end entity ;

architecture arc of pc_bench is

	component Clock is
		port(
		clk : out std_logic 
	  );
	end component Clock ; 
	
	component pc is

		generic(
			add_size : integer range 1 to 8
		) ; 
		
		port(
			clk   : in  std_logic ; 
			i_wt  : in  std_logic ; -- wait
			i_set : in  std_logic ; 
			i_add : in  std_logic_vector(add_size-1 downto 0)  ; 
			q_out : out std_logic_vector(add_size-1 downto 0)  
		) ;
		
	end component pc ; 	
	
	signal clk : std_logic ; 
	
	signal l_wt  : std_logic := '0' ; 
	signal l_set : std_logic := '0' ; 
	signal l_add : std_logic_vector(7 downto 0) := (others=>'0') ; 
	signal l_out : std_logic_vector(7 downto 0) ; 
	
	
	
begin

	clock_inst_0 : Clock
				   port map(clk=>clk) ; 

	pc_inst_0 : pc 
				generic map(add_size=>8)
				port map(clk   => clk,
						 i_wt  => l_wt,
						 i_set => l_set,
						 i_add => l_add,
						 q_out => l_out) ; 
						 
	process(clk)
	begin 
		if rising_edge(clk) then
			if (unsigned(l_out) = 10) then
				l_set <= '1' ; 
				l_add <= "10000000" ;
			else 
				l_set <= '0' ; 
			end if ;
			if (unsigned(l_out) > 128) then
				l_wt <= '1' ;
			end if ;		
		end if ; 
	end process ;

end architecture arc ; 