 library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
 
entity bram_sp is
	generic (
		DATA    : integer := 72;
		ADDR    : integer := 10
	);
	port (
		clk   : in  std_logic;
		sp_wr    : in  std_logic;
		sp_addr  : in  std_logic_vector(ADDR-1 downto 0);
		sp_din   : in  std_logic_vector(DATA-1 downto 0);
		sp_dout  : out std_logic_vector(DATA-1 downto 0) 
	);
end bram_sp;
 
architecture rtl of bram_sp is
    -- Shared memory
    type mem_type is array ( (2**ADDR)-1 downto 0 ) of std_logic_vector(DATA-1 downto 0);
    shared variable mem : mem_type := (others=>(others=>'0'));
begin
 
-- Port A
process(clk)
begin
    if(rising_edge(clk)) then
        if(sp_wr='1') then
            mem(conv_integer(sp_addr)) := sp_din;
        end if;
        sp_dout <= mem(conv_integer(sp_addr));
    end if;
end process;
 
end rtl;