library IEEE                    ;
use IEEE.STD_LOGIC_1164.ALL     ; 
use IEEE.STD_LOGIC_ARITH.ALL    ;
use IEEE.STD_LOGIC_UNSIGNED.ALL ;


entity comparator_8bits is

	port(
		i_A : in std_logic_vector(7 downto 0) ;
		i_B : in std_logic_vector(7 downto 0) ;
		q_eq : out std_logic ; 
		q_gr : out std_logic
	) ; 

end entity comparator_8bits ; 


architecture behavioral of comparator_8bits is 

	signal x: std_logic_vector(7 downto 0) ; 
	signal x_and : std_logic_vector(7 downto 0) ;
	signal x_or  : std_logic_vector(7 downto 0) ;


begin

	x <= not(i_A xor i_B) ; 
	x_and(7) <= x(7)  ; 
	x_and_generate : for I in 1 to 7 generate
		x_and(7-I) <= x_and(8-I) and x(7-I) ; 	
	end generate x_and_generate ; 
	x_or(7) <= i_A(7) and (not(i_B(7)));
	x_or_generate : for I in 1 to 7 generate
		x_or(7-I) <= x_or(8-I) or (x_and(8-I) and (i_A(7-I) and not(i_B(7-I)))) ; 
	end generate x_or_generate ; 
	q_gr <= x_or(0) ; 
	q_eq <= x_and(0) ; 
	

	


end architecture behavioral ; 