library IEEE                    ;
use IEEE.STD_LOGIC_1164.ALL     ; 
use IEEE.STD_LOGIC_ARITH.ALL    ;
use IEEE.STD_LOGIC_UNSIGNED.ALL ;
use IEEE.MATH_REAL.ALL; -- Pour la fonction ceil notamment. 


entity divisor is
	port(
		clk : in std_logic ; 
		i_LOAD : in std_logic ; 		
		i_A : in std_logic_vector(15 downto 0) ;
		i_B : in std_logic_vector(15 downto 0) ;
		q_mult : out std_logic_vector(15 downto 0) ;
		rdy : out std_logic ;
		overflow : out std_logic 
	) ; 
end entity divisor ;

architecture behave of divisor is

-- COMPONENTS --------------------------------------------

	component adder is
		port(
			i_A : in std_logic_vector(15 downto 0) ; 
			i_B : in std_logic_vector(15 downto 0) ; 
			i_carry : in std_logic ; 
			q_add    : out std_logic_vector(15 downto 0) ;
			overflow : out std_logic 
		) ; 
	end component adder ; 

---------------------------------------------------------	


	signal l_A : std_logic_vector(31 downto 0) := (others=>'0'); 
	signal l_B : std_logic_vector(15 downto 0) := (others=>'0'); 
	signal not_l_B : std_logic_vector(15 downto 0) ;  
	signal l_q : std_logic_vector(16 downto 0) := "00000000000000001" ;
	
	signal l_substraction : std_logic_vector(15 downto 0) ; 
	
	
	
	signal l_gr : std_logic := '0' ; 
	
    function To_Std_Logic(L: BOOLEAN) return std_ulogic is
    begin
        if L then
            return('1');
        else
            return('0');
        end if;
    end function To_Std_Logic; 	

begin

	adder_inst_0 : adder
				   port map(
					i_A => l_A(31 downto 16),
					i_B => not_l_B,
					i_carry => '1',
					q_add => l_substraction
					) ; 
					
				   

	not_l_B <= not(l_B) ; 
	l_gr <= To_Std_Logic((conv_integer(l_A(31 downto 16)) >= conv_integer(l_B))) ;

	process(clk)
	begin
		if rising_edge(clk) then
			if (i_LOAD='1') then
				l_A(15 downto 0) <= i_A ;
				l_B(15 downto 0) <= i_B ; 
			else
				if (l_q(16)='0') then
					if (l_gr='1') then
						l_A(31 downto 16) <= l_substraction ; 
						l_q(0) <= '1' ; 
					else
						l_A <= l_A(30 downto 0) & '0' ; 
						l_q <= l_q(15 downto 0) & '0' ; 
					end if ;  -- fin condition soustraction.
				end if ; -- fin condition l_q			
			end if ; -- fin condition load ;
		end if ; -- fin condition horloge. 
	end process ;
	
	rdy    <= l_q(16) ; 
	q_mult <= l_q(15 downto 1) & l_gr ; 


end architecture behave ; 
