library IEEE                    ;
use IEEE.STD_LOGIC_1164.ALL     ; 
use IEEE.STD_LOGIC_ARITH.ALL    ;
use IEEE.STD_LOGIC_UNSIGNED.ALL ;
use IEEE.MATH_REAL.ALL; -- Pour la fonction ceil notamment. 


entity full_adder is
	port(
		i_A : in std_logic ; 
		i_B : in std_logic ; 
		i_carry : in std_logic ;
		q_add   : out std_logic ;
		q_carry : out std_logic 
	) ; 
end entity full_adder ; 


architecture behave of full_adder is
begin
	q_add  	<= i_A xor i_B xor i_carry ;  
	q_carry <= (i_A and i_B) or (i_A and i_carry) or (i_B and i_carry) ; 
end architecture behave ; 