library IEEE                    ;
use IEEE.STD_LOGIC_1164.ALL     ; 
use IEEE.STD_LOGIC_ARITH.ALL    ;
use IEEE.STD_LOGIC_UNSIGNED.ALL ;



entity pc is

	generic(
		add_size : integer range 1 to 8
	) ; 
	
	port(
		clk : in std_logic ; 
		i_wt  : in std_logic ; -- wait
		i_set : in std_logic ; 
		i_add : in std_logic_vector(add_size-1 downto 0) ;
		q_out : out std_logic_vector(add_size-1 downto 0) 
	) ;
	
end entity ; 


architecture arc of pc is
	signal l_pc : std_logic_vector(add_size-1 downto 0) := (others=>'0') ; 
begin
	process(clk)
	begin
		if rising_edge(clk) then
			if (i_wt='0') then
				if (i_set='1') then
					l_pc <= i_add ;
				else
					l_pc <= l_pc+1 ; 
				end if ; -- fin i_set
			end if ; -- fin i_wt
		end if ; -- fin condition horloge ;
	end process ; 
	 q_out <= l_pc ; 
end architecture arc ; 
		
		
		